﻿Option Strict On

Imports System.IO
Imports Microsoft.VisualBasic.FileIO

Public Class frmMain

    Private Sub Parse(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles cmdParse.Click

        ' Datenquelle generieren
        ' Hier wird ein Speicherstream verwendet - Der Parser funktioniert mit 
        '  allen Streams, v.A. File-Streams
        Dim CsvBytes = System.Text.Encoding.UTF8.GetBytes(txtSource.Text)
        Dim CsvStream = New MemoryStream(CsvBytes)

        ' CSV-Parser erstellen - Hier wird als Datenquelle die Eingabe gesetzt
        ' Es kann genauso gut ein Dateiname oder ein anderer Stream 
        '  gesetzt werden
        Using Parser = New FileIO.TextFieldParser(CsvStream)
            ' Parser einrichten
            With Parser
                ' Durch Zeichen getrennte Datensätze
                .TextFieldType = FieldType.Delimited

                ' Trennstrings setzen - Erwartet ein Array, hier wird nur 
                '  eines verwendet
                .Delimiters = New String() {txtDelimiter.Text}

                ' Leerzeichen an den Datenelementen löschen
                .TrimWhiteSpace = True
            End With

            Dim Index = 0

            ' Alle Datensätze durchgehen
            Do Until Parser.EndOfData
                Index += 1

                ' Wenn eine Zeile falsch aufgebaut ist, kann hier der Fehler 
                '  MalformedLineException auftreten.
                ' Aktuelle Datenzeile parsen - Dieser Aufruf ist Kernstück des 
                '  ganzen Programms und gibt ein Array aus Strings zurück
                Dim Row = Parser.ReadFields

                ' Anzeigen
                Call lstItems.Items.Clear()
                For Each Item In Row
                    Call lstItems.Items.Add(Item)
                Next

                lblRowNum.Text = Index.ToString
                If MessageBox.Show("Parsen fortsetzen?", "Weiter", _
                    MessageBoxButtons.YesNo, MessageBoxIcon.Question) = _
                    Windows.Forms.DialogResult.No Then Exit Do
            Loop
        End Using

        Call MessageBox.Show("Parsen abgeschlossen", "Fertig", _
            MessageBoxButtons.OK, MessageBoxIcon.Information)
        Call CsvStream.Dispose()
    End Sub

End Class
